#include <ioavr.h>
#include "compiler.h"
#include "conf_usb.h"
#include "usb.h"
#include "usb_host_drv.h"
#include "usb_host_transfer.h"
#include "descriptors.h"
#include "spi_rpc.h"

#if (USB_HOST_FEATURE == ENABLED)
U16 getreport=0;

U8 usb_host_hid_enumerated_action(S_Host_usb_device * hiddev)
{
//    U8 i,j;
//    U8 * data_stage;
    
/*
    if (CONTROL_GOOD != host_usb_device_setEx(SET_INTERFACE, 0, 0, 0))
    {
        dprintf("set interface failed\r");
    }
    else
        dprintf("interface Set\r");
*/
    
    
/*    if (CONTROL_GOOD != host_hid_set_idle(0))
    {
        dprintf("failed set idle\r");
    }
*/    
    
/*    
    data_stage=host_get_interface_std_descriptor(HID_REPORT_DESCRIPTOR,0,0,hiddev->ctrl_pipe_nb);
    if (data_stage == NULL)
    {
        dprintf("failed getting hid report descriptor\r");
        return 1;
    }
    j=0;
    dprintf("report descriptor: %x bytes\r",(U8)(hiddev->misc));
    for (i=0;i<(U8)(hiddev->misc);i++)
    {
        dprintf("%02x ",data_stage[i]);
        j++;
        if (j>7){j=0;dprintf("\r");}
    }
 */  
    return 0;
}

#define PS3_NEEDED_SZ 20
#define HID_BUF_SZ 60

static U16 hid_dtasz =PS3_NEEDED_SZ;

static U8 hid_databuf[HID_BUF_SZ];
static U8 * hid_report=hid_databuf;

static U8 RB_tilt_seen = 0;

void usb_host_hid_task(S_Host_usb_device*dev)
{
    U8 i;
/*
    if (Is_new_device_connection_event())
    {
        Host_select_pipe(1);
        Host_continuous_in_mode();
        Host_unfreeze_pipe();
    }
    

    Host_select_pipe(dev->ep_pipes[0]);
     if(Is_host_in_received())
      {
         if(Is_host_stall()==FALSE)
         {
            databuf[0]=Host_read_byte();
            databuf[1]=Host_read_byte();
            databuf[2]=Host_read_byte();
            databuf[3]=Host_read_byte();
            databuf[4]=Host_read_byte();
            databuf[5]=Host_read_byte();
            
            dprintf("Read Interrupt bytes %x %x %x %x %x %x\r",
                    databuf[0],
                    databuf[1],
                    databuf[2],
                    databuf[3],
                    databuf[4],
                    databuf[5]
                    );
         }
         else
             dprintf("Read staal\r");
         Host_ack_in_received(); 
         Host_send_in();
      }
*/
    
    if (getreport>0x0a)
    {
        getreport=0;
      //  PINA_Bit1=1;
    
        if (dev->device_state==DEVICE_READY)
        {
            
            hid_dtasz=PS3_NEEDED_SZ;
            host_get_data(dev->ep_pipes[0], &hid_dtasz, hid_report);
            if (hid_dtasz>0)
            {
                // RB tilt duration is too short (one package)
                // this will make it last for a sec.s
                i = *(hid_report+0);
                if (RB_tilt_seen) 
                {
                    i |= 0x20;
                    RB_tilt_seen--;
                    *(hid_report+0)=i;
                }
                else if (i & 0x20) // RB TILT
                    RB_tilt_seen=100;
                    
                i=0;
                for(;i<PS3_NEEDED_SZ;)
                {
                    if (i==3 || i==4)i++;
                    if (hid_databuf[i]!=hid_databuf[i+HID_BUF_SZ/2])
                        break;
                    i++;
                }
                if (i<=(PS3_NEEDED_SZ-1)) // changed
                {
                    *(hid_report+3) = *(hid_report+5);
                    *(hid_report+4) = *(hid_report+19);

                    spi_rpc_write_report(5,hid_report);

                    // swap buffers;
                    if (hid_report == hid_databuf) hid_report=hid_databuf+HID_BUF_SZ/2;
                    else hid_report = hid_databuf;
                }
            }
        }
    }
}
#endif
